<template>
  <div style="margin-top: 20px">
    <v-container class="fill-height">
      <v-row align="center" justify="center">
        <v-col cols="12">
          <v-card>
            <v-toolbar flat>
              <v-toolbar-title>
                <v-icon color="info" class="mx-2">map</v-icon>พื้นที่
                {{ paramObj.locateName }}-
                {{ paramObj.lockerCode }}
              </v-toolbar-title>
              <v-spacer></v-spacer>
            </v-toolbar>
          </v-card>
        </v-col>
        <v-col cols="12">
          <v-card>
            <v-toolbar flat>
              <v-toolbar-title>
                <v-icon color="info" class="mx-2">search</v-icon>ค้นหา
              </v-toolbar-title>
              <v-spacer></v-spacer>
            </v-toolbar>
            <v-card-text>
              <FilterIncome v-model="obj" />
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="orange"
                dark
                depressed
                @click="fetchIncome('reset')"
              >
                <v-icon left> search </v-icon>
                ค้นหา
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
        <v-col cols="12">
          <v-card class="mx-auto">
            <v-card-text>
              <!-- Title -->
              <v-overlay :value="overlay" :absolute="absolute">
                <div class="text-center">
                  <v-progress-circular
                    :size="70"
                    :width="7"
                    color="amber"
                    indeterminate
                  ></v-progress-circular>
                </div>
              </v-overlay>
              <v-toolbar flat>
                <v-toolbar-title
                  ><v-icon color="info" class="mx-2" large>timeline</v-icon
                  >รายละเอียดรายได้</v-toolbar-title
                >
                <v-divider class="mx-4" inset vertical></v-divider>

                <v-btn
                  :loading="loadingExport"
                  v-show="!loading"
                  :disabled="loadingExport"
                  color="green white--text"
                  @click="exportExcel"
                  v-if="items.length > 0"
                >
                  ดาวน์โหลดไฟล์ Excel
                  <v-icon right> backup </v-icon>
                </v-btn>

                <v-spacer></v-spacer>
                <v-btn
                  color="info"
                  :to="{ name: 'income-locker', query: { payload: paramObj } }"
                  depressed
                >
                  <v-icon>reply</v-icon> กลับ
                </v-btn>
              </v-toolbar>
              <br />

              <!-- Loading Data -->
              <Loading
                v-if="loading"
                :propLoading="loading"
                propText="กรุณารอสักครู่"
              />
              <TableIncomeLockerRoom
                :items="items"
                :loading="loading"
                :paramObj="paramObj"
                :propHeader="obj.durationType"
                v-show="!loading"
                @update-table-parent="updateParentData"
              />
              <!-- Pagination -->
              <div class="text-center my-1" v-if="items.length > 0">
                <v-pagination
                  v-model="page"
                  :length="length"
                  :total-visible="7"
                  circle
                  @input="handlePageChange"
                  v-show="!loading"
                ></v-pagination>
              </div>
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
import TableIncomeLockerRoom from "../../../components/income/TableIncomeLockerRoom";
import FilterIncome from "../../../components/income/FilterIncome";
import Loading from "../../../components/loading/Loading";
import { IncomenModel } from "./model/income";
import axios from "axios";
import moment from "moment";
export default {
  components: {
    Loading,
    TableIncomeLockerRoom,
    FilterIncome,
  },
  data() {
    return {
      obj: {
        dates: [],
        months: [],
        years: [],
        durationType:
          localStorage.getItem("type") == null
            ? "W"
            : localStorage.getItem("type"),
      },
      page: 1,
      perPage: 5,
      items: [],
      paramObj: {},
      length: null,
      loading: true,
      loadingExport: false,
      dataExport: {},
      overlay: false,
      absolute: true,
      role: this.$store.getters["auth/roleUser"],
    };
  },
  mounted() {
    this.paramObj = this.$route.query.payload;
    if (this.paramObj === undefined) {
      this.$router.push({
        path: `/income-location`,
      });
    } else {
      this.defaultDate();
      this.fetchIncome();
    }
  },
  methods: {
    updateParentData(i) {
      if (i) this.fetchLocation();
    },
    async exportExcel() {
      this.loadingExport = true;
      let data = {
        AccountId: this.dataExport.AccountId,
        page: this.dataExport.page,
        perPage: this.dataExport.perPage,
        DurationType: this.dataExport.DurationType,
        StartDate: this.dataExport.StartDate,
        EndDate: this.dataExport.EndDate,
        LockerId: this.dataExport.LockerId,
      };
      await this.$store.dispatch("income/getIncomeExcelLockerRoom", data);
      let res = this.$store.getters["income/urlExport"];
      let fileName = `${res}`.split("/")[4];
      axios({
        url: res,
        method: "GET",
        responseType: "blob",
      }).then((response) => {
        var fileURL = window.URL.createObjectURL(new Blob([response.data]));
        var fileLink = document.createElement("a");

        fileLink.href = fileURL;
        fileLink.setAttribute("download", fileName);
        document.body.appendChild(fileLink);

        fileLink.click();
        fileLink.remove();
        this.loadingExport = false;
      });
    },
    daysInMonth(month, year) {
      return new Date(year, month, 0).getDate();
    },
    defaultDate() {
      let dateTh = moment(this.$options.filters.dateNow())
        .add(543, "year")
        .format("YYYY-MM-DD");
      this.obj.dates[0] = dateTh;
      let date = dateTh.split("-");
      let celDate = parseInt(date[2]) - 6;
      if (celDate <= 0) {
        let monthNew = parseInt(date[1]) - 1;
        let yearNew = parseInt(date[0]);
        let calMonthNew = monthNew;
        if (monthNew == 0) {
          yearNew = parseInt(date[0]) - 1;
          calMonthNew = 12 - monthNew;
        }
        let dayCount = this.daysInMonth(calMonthNew, yearNew);
        let unNegative = Math.abs(celDate);
        let calResult = parseInt(dayCount) - unNegative;

        let newDate = moment(`${yearNew}-${calMonthNew}-${calResult}`).format(
          "YYYY-MM-DD"
        );
        this.obj.dates.push(newDate);
      } else {
        let newDate = moment(`${date[0]}-${date[1]}-${celDate}`).format(
          "YYYY-MM-DD"
        );
        this.obj.dates.push(newDate);
      }
    },
    async handlePageChange(value) {
      this.page = value;
      await this.fetchIncome();
    },
    async fetchIncome(text) {
      if (text != undefined) {
        if (this.obj.dates.length != 0) {
          this.obj.StartDate = this.obj.dates[0];
          this.obj.EndDate = this.obj.dates[1];
        }
        if (this.obj.months.length != 0) {
          this.obj.StartDate = this.obj.months[0];
          this.obj.EndDate = this.obj.months[1];
        }
        if (this.obj.years.length != 0) {
          this.obj.StartDate = this.obj.years[0];
          this.obj.EndDate = this.obj.years[1];
        }
        localStorage.setItem("type", this.obj.durationType);
        localStorage.setItem("start", this.obj.StartDate);
        localStorage.setItem("end", this.obj.EndDate);
      }
      let param = IncomenModel.incomeLockerRoom(
        this.obj,
        this.page,
        this.perPage,
        text,
        this.paramObj
      );
      this.dataExport = param;
      this.page = param.page;
      await this.$store.dispatch("income/getIncomeLockerRoom", param);
      let res = this.$store.getters["income/result"];
      let error = this.$store.getters["income/error"];
      if (error == true) {
        this.$router.replace({
          path: `/income-location`,
        });
      }
      for (let i in res.content.incomeLockerRooms) {
        res.content.incomeLockerRooms[i].total = res.content.incomeLockerRooms[
          i
        ].incomeResult
          .reduce((arr, val) => parseFloat(arr) + parseFloat(val), 0.0)
          .toFixed(1);
        res.content.incomeLockerRooms[i].result = res.content.rangeTitle;
      }
      let loading = this.$store.getters["income/loading"];
      this.items = res.content.incomeLockerRooms;
      this.length = res.length;
      this.loading = loading;
    },
  },
};
</script>

<style></style>
